// Generated by CoffeeScript 1.12.2
(function() {
  var Promise, RE_BOUNDARY, Readable, dicer, parseInto, parser;

  parser = require('http-parser-js').HTTPParser;

  dicer = require('dicer');

  Readable = require('readable-stream');

  Promise = require('bluebird');

  RE_BOUNDARY = /^multipart\/.+?(?:;\s?boundary=(?:(?:"(.+)")|(?:([^\s]+))))$/i;

  parseInto = function(dst, boundary) {
    var d, position;
    d = new dicer({
      boundary: boundary[1] || boundary[2]
    });
    d.pending = [];
    position = 0;
    d.on('part', function(part) {
      var onEnd, request, slot;
      slot = position++;
      request = {
        headers: {},
        method: null,
        url: null,
        data: [],
        body: {},
        _isChangeSet: false
      };
      onEnd = function(part) {
        return function() {
          return dst[slot] = part;
        };
      };
      part.on('header', function(header) {
        return Object.assign(request.headers, header);
      });
      return part.on('data', function(data) {
        var error, m1, p, pend, ref;
        if (m1 = RE_BOUNDARY.exec((ref = request.headers['content-type']) != null ? ref[0] : void 0)) {
          pend = new Promise(function(resolve, reject) {
            var bodyStream, d1, finish;
            d1 = parseInto(request.data, m1);
            finish = onEnd({
              _isChangeSet: true,
              changeSet: request.data
            });
            d1.on('finish', function() {
              finish();
              return resolve();
            });
            bodyStream = new Readable();
            bodyStream.pipe(d1);
            bodyStream.push(data.toString());
            return bodyStream.push(null);
          });
          return d.pending.push(pend);
        } else {
          part.on('end', onEnd(request));
          p = new parser(parser.REQUEST);
          p.execute(data);
          p.finish();
          p.close();
          request.method = parser.methods[p.info.method];
          request.url = p.info.url;
          try {
            request.data = JSON.parse(p.line);
            return request.body = request.data;
          } catch (error1) {
            error = error1;
            request.data = {};
            return request.body = {};
          }
        }
      });
    });
    return d;
  };

  exports.multiReq = function(req, res, next) {
    var d, m;
    req.batch = [];
    if (req.method === 'POST' && (m = RE_BOUNDARY.exec(req.headers['content-type']))) {
      d = parseInto(req.batch, m);
      d.on('finish', function() {
        return Promise.all(d.pending).then(function() {
          return next();
        });
      });
      return req.pipe(d);
    } else {
      return next();
    }
  };

}).call(this);
